m32r: fix __get_user()
[linux-2.6-block.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0
SR
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
a7df4716 65 -lutil -lrt -lpthread ${1}
1f2bfbd0
SR
66 rm -f linux
67 fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74 info KSYM ${2}
75 local kallsymopt;
76
b92021b0
RR
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
6895f97e
JH
79 fi
80
1f2bfbd0 81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 82 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
83 fi
84
4d5d5664 85 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
86 kallsymopt="${kallsymopt} --absolute-percpu"
87 fi
88
2213e9a6
AB
89 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
90 kallsymopt="${kallsymopt} --base-relative"
91 fi
92
00e6c28c
SR
93 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
94 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 95
a0439342
AB
96 local afile="`basename ${2} .o`.S"
97
98 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
99 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
100}
101
102# Create map file with all symbols from ${1}
103# See mksymap for additional details
104mksysmap()
105{
106 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
107}
108
1347a2ce
LT
109sortextable()
110{
111 ${objtree}/scripts/sortextable ${1}
112}
113
1f2bfbd0 114# Delete output files in case of error
1f2bfbd0
SR
115cleanup()
116{
117 rm -f .old_version
118 rm -f .tmp_System.map
119 rm -f .tmp_kallsyms*
120 rm -f .tmp_version
121 rm -f .tmp_vmlinux*
122 rm -f System.map
123 rm -f vmlinux
124 rm -f vmlinux.o
125}
126
ab160dbb
SB
127on_exit()
128{
129 if [ $? -ne 0 ]; then
130 cleanup
131 fi
132}
133trap on_exit EXIT
134
135on_signals()
136{
137 exit 1
138}
139trap on_signals HUP INT QUIT TERM
140
1f2bfbd0
SR
141#
142#
143# Use "make V=1" to debug this script
144case "${KBUILD_VERBOSE}" in
145*1*)
146 set -x
147 ;;
148esac
149
150if [ "$1" = "clean" ]; then
151 cleanup
152 exit 0
153fi
154
155# We need access to CONFIG_ symbols
423a8155
MM
156case "${KCONFIG_CONFIG}" in
157*/*)
158 . "${KCONFIG_CONFIG}"
159 ;;
160*)
161 # Force using a file from the current directory
162 . "./${KCONFIG_CONFIG}"
163esac
1f2bfbd0
SR
164
165#link vmlinux.o
166info LD vmlinux.o
167modpost_link vmlinux.o
168
169# modpost vmlinux.o to check for section mismatches
170${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
171
172# Update version
173info GEN .version
174if [ ! -r .version ]; then
175 rm -f .version;
176 echo 1 >.version;
177else
178 mv .version .old_version;
179 expr 0$(cat .old_version) + 1 >.version;
180fi;
181
182# final build of init/
6b90bd4b 183${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
1f2bfbd0
SR
184
185kallsymso=""
186kallsyms_vmlinux=""
187if [ -n "${CONFIG_KALLSYMS}" ]; then
188
189 # kallsyms support
190 # Generate section listing all symbols and add it into vmlinux
191 # It's a three step process:
192 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
193 # but __kallsyms is empty.
194 # Running kallsyms on that gives us .tmp_kallsyms1.o with
195 # the right size
196 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
197 # the right size, but due to the added section, some
198 # addresses have shifted.
199 # From here, we generate a correct .tmp_kallsyms2.o
200 # 2a) We may use an extra pass as this has been necessary to
201 # woraround some alignment related bugs.
202 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
203 # 3) The correct ${kallsymso} is linked into the final vmlinux.
204 #
205 # a) Verify that the System.map from vmlinux matches the map from
206 # ${kallsymso}.
207
208 kallsymso=.tmp_kallsyms2.o
209 kallsyms_vmlinux=.tmp_vmlinux2
210
211 # step 1
212 vmlinux_link "" .tmp_vmlinux1
213 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
214
215 # step 2
216 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
217 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
218
219 # step 2a
220 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
221 kallsymso=.tmp_kallsyms3.o
222 kallsyms_vmlinux=.tmp_vmlinux3
223
224 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
225
226 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
227 fi
228fi
229
230info LD vmlinux
231vmlinux_link "${kallsymso}" vmlinux
232
1347a2ce
LT
233if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
234 info SORTEX vmlinux
235 sortextable vmlinux
236fi
237
1f2bfbd0
SR
238info SYSMAP System.map
239mksysmap vmlinux System.map
240
241# step a (see comment above)
242if [ -n "${CONFIG_KALLSYMS}" ]; then
243 mksysmap ${kallsyms_vmlinux} .tmp_System.map
244
245 if ! cmp -s System.map .tmp_System.map; then
5369f550 246 echo >&2 Inconsistent kallsyms data
367e43c5 247 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
248 exit 1
249 fi
250fi
251
252# We made a new kernel - delete old version file
253rm -f .old_version